/*
 * State.java
 *
 * Created on 11. jen 2006, 23:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pa161.uloha_1;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author xmatena
 */
public class State {
    
    int mis_left;
    int eat_left;
    boolean boat_left;
    State previous;
    int last_op;
    
    /** Creates a new instance of State */
    public State(int mis, int eat, boolean boat_left,State previous, int last_op) {
        this.mis_left = mis;
        this.eat_left = eat;
        this.boat_left = boat_left;
        this.previous = previous;
        this.last_op = last_op;
    }
    
    public State getLastState() {
        return previous;
    }
    
    public int getLastOperator() {
        return last_op;
    }
    
    public boolean isSuccessful() {
        return ((mis_left == 0) && (eat_left == 0));
        /*boat_left == false neni nutno kontrolovat*/
    }
    
    public List<State> getSuccessors() {
        List<State> successors = new ArrayList<State>(5);
                    
        for (int i=1; i < 6; i++) {
            State s = createMoveIfPossible(i);
            if (s!=null) {
                successors.add(s);
            }
        }
        
        return successors;
    }
    
    public String toString() {
        return ("[" + last_op + "] ("+ mis_left + "," + eat_left + "," + (boat_left?"1":"0") + ")"
                + "||(" + (3 - mis_left) + "," + (3 - eat_left) + "," + (boat_left?"0":"1") + ")");
    }
    
    private State createMoveIfPossible(int num) {
        int mis_right = 3 - mis_left;
        int eat_right = 3 - eat_left;
        boolean boat_right = !boat_left;
        
        int mis_on_boat=0;
        int eat_on_boat=0;
        
        switch (num) {
            case 1 : {
                mis_on_boat = 1;
                eat_on_boat = 0;
            } break;
            case 2 : {
                mis_on_boat = 2;
                eat_on_boat = 0;
            } break;
            case 3 : {
                mis_on_boat = 0;
                eat_on_boat = 1;
            } break;
            case 4 : {
                mis_on_boat = 0;
                eat_on_boat = 2;
            } break;
            case 5 : {
                mis_on_boat = 1;
                eat_on_boat = 1;
            } break;
        }
        
        int lrfactor = boat_left ? 1 : -1;
        
        boolean initOK;
        boolean leftOK;
        boolean rightOK;
        
        
        initOK = ((boat_left && ((mis_left >= mis_on_boat) && (eat_left >= eat_on_boat)))
        || (boat_right &&((mis_right >= mis_on_boat) && (eat_right >= eat_on_boat))));
        if (initOK) {
            leftOK = (mis_left - lrfactor * mis_on_boat) >= (eat_left - lrfactor * eat_on_boat);
            leftOK |= (mis_left - lrfactor*mis_on_boat == 0);
            
            if (leftOK) {
                rightOK = (mis_right + lrfactor * mis_on_boat) >= (eat_right + lrfactor * eat_on_boat);
                rightOK |= (mis_right + lrfactor*mis_on_boat == 0);
                
                if (rightOK) {
                    return new State(
                            mis_left - lrfactor*mis_on_boat,
                            eat_left - lrfactor*eat_on_boat,
                            !boat_left,
                            this,
                            num);
                }
            }
        }
        
        return null;
    }
}
